Bug 5940 - <svg> inside <body> incorrectly extends over top/bottom borders
Summary: <svg> inside <body> incorrectly extends over top/bottom borders
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: SVG (show other bugs)
Version: 420+
Hardware: Macintosh OS X 10.4
: P2 Normal
Assignee: Nobody
URL: http://developer.mozilla.org/presenta...
Keywords: NeedsReduction
Depends on: 12207
Blocks:
  Show dependency treegraph
 
Reported: 2005-12-04 23:56 PST by Rob Buis
Modified: 2007-07-14 16:17 PDT (History)
1 user (show)

See Also:


Attachments
Reduced testcase (831 bytes, application/xml)
2005-12-07 04:51 PST, Rob Buis
no flags Details
even better test case (301 bytes, application/xhtml+xml)
2007-06-01 16:03 PDT, Eric Seidel (no email)
no flags Details
Fix z-index problems (1.79 KB, patch)
2007-06-14 13:49 PDT, Rob Buis
mrowe: review-
Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Rob Buis 2005-12-04 23:56:42 PST
Hi,

See topic :)
It seems like the big gradient renders over everyhing else?
Cheers,

Rob.
Comment 1 Rob Buis 2005-12-07 04:51:32 PST
Created attachment 4987 [details]
Reduced testcase

This testcase has script and style elements removed. Also just one svg
shape(rect) and
a form that should display over the svg rect.
Comment 2 Eric Seidel (no email) 2005-12-07 23:47:49 PST
I bet my disabling of RenderLayer creation for svg elements is causing the z-ordering system to be 
confused...
Comment 3 Eric Seidel (no email) 2006-01-15 03:10:42 PST
This will crash recent development builds due to an ASSERT.
Comment 4 Eric Seidel (no email) 2006-01-26 14:54:19 PST
Removing:
    virtual bool requiresLayer() { return false; }
should fix this.  The problem then becomes making sure that they layer code doesnt' cause double-opacity in certain instances, since the SVG render objects handle their own opacity instead of relying on RenderLayer.
Comment 5 Eric Seidel (no email) 2006-08-11 21:50:23 PDT
This seems to be a CSS selector problem at this point.
Comment 6 Eric Seidel (no email) 2006-08-11 21:56:16 PDT
Actually, I was wrong.  This is still a z-order issue.
Comment 7 Eric Seidel (no email) 2007-01-31 04:45:40 PST
It seems that webkit renders it fine now, except for slice.
Comment 8 Eric Seidel (no email) 2007-06-01 15:54:22 PDT
It's still not clipping 100% correctly.  The top and bottom extend too far.
Comment 9 Eric Seidel (no email) 2007-06-01 16:03:18 PDT
Created attachment 14836 [details]
even better test case

This seems to be a CDF interaction problem.  Somehow the SVG thinks it is taller than it should think it is.
Comment 10 Rob Buis 2007-06-14 13:49:22 PDT
Created attachment 15030 [details]
Fix z-index problems

This should fix the last issue. It still needs a testcase, but that should be easy. What is more annoying is that it changes most DRT results. So we may need to wait with it and make RenderSVGRoot output RenderSVGRoot instead of RenderSVGContainer in the DRT in one fell swoop.
Cheers,

Rob.
Comment 11 Eric Seidel (no email) 2007-06-14 13:51:38 PDT
Comment on attachment 15030 [details]
Fix z-index problems

Perfect.  The final patch will need to include test updates as well as this new test.

However the code change itself looks great.  Rob will land this later this week.
Comment 12 Mark Rowe (bdash) 2007-07-06 03:15:21 PDT
Comment on attachment 15030 [details]
Fix z-index problems

Rob said there is an issue with SVG + z-indexing that he needs to discuss with Hyatt before this can be landed.  Marking as r- to get it out of the commit queue for now.
Comment 13 Nikolas Zimmermann 2007-07-14 16:16:25 PDT
Fixed in r24292.